;************************************************************************;
;*	   ᥬ	ࠩ	  Tiny, ᮤঠ騩		*;
;*	  䥩 㭪樨 ⢨  ⮬ GPIO,		*;
;*	        ணࠬ  몠 '᪠', ''.			*;
;*									*;
;*	   ࠩ ᠭ  몥 ࡮ ᥬ (TASM 3.2).		*;
;*	     ப: tasm.exe /z/q/zn/w0/m2/mx	*.asm		*;
;*									*;
;*	 HOLIT Data Systems SoftWare Lab Limited, Kiev,	01.01.02	*;
;************************************************************************;

; 	ࠡ  設 ⨯ 286, 386, 486,	Pentium	...
.286

;  ਢ 㭪樨 	ᯮ㥬 㪠⥫  ⨯ FAR.

;  ஢  ᯮ짮 ࠩ	 ணࠬ 	몥
; '᪠' 室 ᯮ짮 ᫥ ४⨢	:
.MODEL LARGE, PASCAL

;  ஢  ᯮ짮 ࠩ	 ணࠬ 	몥
; '' 室 ᯮ짮 ᫥ ४⨢ :
;.MODEL	LARGE, C

LOCALS

.CODE

;************************************************************************
;   

; 㭪樨  ࠡ  ஢묨 (묨)  ﬨ
 PUBLIC	InitGPIO		; 樠	⮢ /
 PUBLIC	InGPIO			; ⥭ ஢ 
 PUBLIC	OutGPIO			;  ஢ 

;************************************************************************
;  

;***  ⮢  (W -> ,R	-> ⥭) ***
;*** ।  ६ ***
;*** । 	***

;************************************************************************
;  

;************************************************************************
;*  : void InitGPIO( uInt8 cfgPA, uInt cfgPB )			*
;* 樠 GPIO  A ( GP0-GP7)   B ( GP8-GP15):	*
;* 00 - 室								*
;* FF - 室								*
;************************************************************************
InitGPIO PROC FAR cfgPA : byte, cfgPB : byte
	mov	al, 13h		; Unlock 6117D configuration register.
	out	22h, al		;
	mov	al, 0c5h	;
	out	23h, al		;

	mov	al, 4eh		; Enable GPIO[7-0]
	out	22h, al		;
	mov	al, cfgPA	; If AL	fill "FF", then
				; GPIO set as output pin.
	out	23, al		; User can be set logic	"1"
				; of OUT direction.

	mov	al, 4fh		; Enable GPIO[8-15]
	out	22h, al		;
	mov	al, cfgPB	; If AL	fill "00", then
				; GPIO set as input pin..
	out	23h, al		; User can be set logic	"0"
				; of IN	direction.
	ret
ENDP

;****************************************************************
;*  : uInt8 InGPIO( uInt8 prt ) 				*
;* 頥 ﭨ 8- 譨 ஢ TTL , 	*
;* 'prt' 㪠뢠    8- ⮢:			*
;* 0 -  A ( GP0-GP7)					*
;* 1 -  B ( GP8-GP15)					*
;****************************************************************
InGPIO PROC FAR nprt : byte
	mov	al, 46h		; Input	data port GPIO[7-0]
	mov	ah, nprt
	or	ah, ah
	jz	@@
	mov	al, 4ch		; Input	data port GPIO[8-15]
@@:
	out	22h, al		; Index register

	in	al, 23h		; Read data from GPIO into AL
	mov	bl,255
	sub	bl,al
	mov	al,bl
	ret
ENDP

;****************************************************************
;*  : void OutGPIO( uInt8 prt, uInt8 dCode )		*
;* 㭪 ⠭ 譨 ஢ ,			*
;* 'prt' 㪠뢠    8- ⮢ : 		*
;* 0 -  A ( GP0-GP7)					*
;* 1 -  B ( GP8-GP15)					*
;* 'dCode' - ᮮ⢥騩 8- .			*
;****************************************************************
OutGPIO PROC FAR nprt : BYTE, dCode : BYTE
	mov	al, 47h		; Output data port GPIO[7-0]
	mov	ah, nprt
	or	ah, ah
	jz	@@
	mov	al, 4dh		; Output data port GPIO[8-15]
@@:
	out	22h, al         ; Index register

	mov	al, dCode	; Data out value is dCode
	mov	bl,255
	sub	bl,al
	mov     al,bl
	out	23h, al		; to output pin

	ret
ENDP

END


ICOP Embedded 386SX CPU	Tiny Board User's Manual

General	Purpose	I/O

; M6117D supports 16 independent GPOs and GPIs.	This group of GPOs
; does not need	external 74LS373 to latch as generate purpose output.
; Also this group of GPIs do not share signals with the	ISA data bus, so no
; external 74LS245 is required either.
; At boot time the state of the	GPIO ports can be set in the BIOS.
; Go to	BIOS Setup's "Advanched	Chipset	Setup"
