{{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P+,Q-,R-,S-,T-,V-,X+,Y-}

{$M 1024,0,0}
Unit UartRtDt;

INTERFACE

Function InitCOM( port, rate, nBits, stopBits, parity, tParity : word ) : word;
Function CloseCOM( port : word ) : word;
Function Send( dataBuf : pointer; nBytes : word ) : word;
Function SendWait( dataBuf : pointer; nBytes : word ) : word;
Function Receive( dataBuf : pointer; nBytes : word ) : word;
Function ReceiveN( dataBuf : pointer; nBytes : word ) : word;
Function ClrCOM : word;
Function Ready4Receive : wordBool;

Function SetMaskRtsDtr485( snd, rcv : byte ) : word;
Function SendReceiveASCIIZ( sndBuf, rcvBuf : pointer ) : word;

IMPLEMENTATION

Var
    comRG, statRG : word;
    sndMask, rcvMask : byte;
    timeOut : word;

Function SetMaskRtsDtr485( snd, rcv : byte ) : word; Assembler;
Asm
	mov	al, snd
	and	al, 00000011b
	mov     sndMask, al
	mov	al, rcvMask
	and	al, 00000011b
	mov     rcvMask, al
	mov	ax, cx
End;

{ port = 1,2,3 or 4 }
{ Baud rate = 115200/rate}
{ nBits = 5, 6, 7 or 8 }
{ stopBits = 1, 2 }
{ parity = 0 (off), 1 (on) }
{ tParity = 0 (odd-), 1 (even-) }
{ Return: 0 - no errors }
Function InitCOM( port, rate, nBits, stopBits, parity, tParity : word ) : word; Assembler;
Asm
	xor	cx, cx
	mov	bx, port
	dec	bx
	cmp	bx, 4
	jb	@@PortOK
	inc	cx
	jmp	@@fin
@@PortOK:
	shl	bx, 1
	add	bx, 400h
@@SetPort:
	xor	ax, ax
	mov	es, ax
	mov	dx, es:[bx]     { bx = 400h, 402h, 404h or 406h }
	mov	comRG, dx
	add	dx, 5
	mov	statRG, dx

	cli

	sub	dx, 2           { 3fbh }
	mov	al, 10000000b
	out	dx, al
	nop
	sub	dx, 3           { 3f8h }
	mov	ax, rate      	{ Baud rate = 115200/rate}
	out	dx, ax
	nop
	mov	ax, nBits
	dec	ax
	and	al, 00000011b
	mov	bx, stopBits
	and	bl, 00000010b
	shl	bl, 1
	or	al, bl
	mov	bx, parity
	shl	bl, 3
	or	al, bl
	mov	bx, tParity
	shl	bl, 4
	or	al, bl
	and	al, 00011111b   { Control word }
	add	dx, 3           { 3fbh line control }
	out	dx, al
	nop
	inc	dx              { 3fch modem control }
	mov	al, 00001000b	{ bit1 - RTS, bit0 - DTR }
{DTR/RTS}or	al, rcvMask
	out	dx, al
	nop
	sub	dx, 2		{ 3fah FIFO control }
	mov	al, 11000111b
	out     dx, al
	nop
	dec	dx           	{ 3f9h interrupt enable }
	xor	al, al
	out	dx, al          { Disable COM INT }

	sti

	mov	ax, rate
	shl	ax, 8          { timeOut = ?? chars }
{	xor	ax, ax { 65536 mcs }
	mov	timeOut, ax

	mov	dx, statRG
	in	al, dx
	and	al, 00000001b
	jz	@@fin
	sub	dx, 5
	in	al, dx
@@fin:
	mov	ax, cx
End;

Function CloseCOM( port : word ) : word; Assembler;
Asm
	xor	cx, cx
	mov	bx, port
	dec	bx
	cmp	bx, 4
	jb	@@PortOK
	inc	cx
	jmp	@@fin
@@PortOK:
	shl	bx, 1
	add	bx, 400h
@@SetPort:
	xor	ax, ax
	mov	es, ax
	mov	dx, es:[bx]     { bx = 400h, 402h, 404h or 406h }
	mov	comRG, dx
	add	dx, 5
	mov	statRG, dx

	cli

	sub	dx, 2           { 3fbh }
	mov	al, 10000000b
	out	dx, al
	nop
	sub	dx, 3           { 3f8h }
	mov	ax, 12      	{ Baud rate = 115200/12 = 9600}
	out	dx, ax
	nop
	add	dx, 3           { 3fbh line control }
	mov	al, 00000011b   { Control word }
	out	dx, al
	nop
	inc	dx              { 3fch modem control }
	mov	al, 00001000b	{ bit1 - RTS, bit0 - DTR }
{DTR/RTS}or	al, rcvMask
	out	dx, al
	nop
	sub	dx, 2		{ 3fah FIFO control }
	mov	al, 00000110b
	out     dx, al
	nop
	dec	dx           	{ 3f9h interrupt enable }
	xor	al, al
	out	dx, al          { Disable COM INT }

	sti

	mov	dx, statRG
	in	al, dx
	and	al, 00000001b
	jz	@@fin
	sub	dx, 5
	in	al, dx
@@fin:
	mov	ax, cx
End;

{ Return: 0 - no errors }
Function Send( dataBuf : pointer; nBytes : word ) : word; Assembler;
Asm
	push	di

	mov	bx, nBytes
	les	di, dataBuf

	mov	dx, statRG

@@sendData:
	mov	cx, timeOut
@@:
	in	al, dx
	and	al, 00100000b
	loopz	@@
	jz	@@fin

	mov	al, byte ptr es:[di]
	inc	di
	sub	dx, 5
	out	dx, al
	add	dx, 5
	dec	bx
	jnz	@@sendData
@@fin:
	mov	ax, bx

	pop	di
End;

{ Return: 0 - no errors }
Function SendWait( dataBuf : pointer; nBytes : word ) : word; Assembler;
Asm
	push	di

	mov	bx, nBytes
	les	di, dataBuf

	mov	dx, statRG

	dec	dx		{ 3fch modem control }
	mov	al, 00001011b   { bit1 - RTS, bit0 - DTR }
	out	dx, al
	inc	dx

@@sendData:
	mov	cx, timeOut
@@:
	in	al, dx
	and	al, 00100000b
	loopz	@@
	jz	@@fin

	mov	al, byte ptr es:[di]
	inc	di
	sub	dx, 5
	out	dx, al
	add	dx, 5
	dec	bx
	jnz	@@sendData

	mov	cx, timeOut
@@wait4fin:
	in	al, dx
	and	al, 01000000b
	loopz	@@wait4fin

@@fin:
	dec	dx		{ 3fch modem control }
	mov	al, 00001000b   { bit1 - RTS, bit0 - DTR }
	out	dx, al
	inc	dx

	mov	ax, bx

	pop	di
End;

Function Ready4Receive : wordBool; Assembler;
Asm
	mov	dx, statRG
	in	al, dx
	and	ax, 1
End;

{ Return: 0 - no errors }
Function Receive( dataBuf : pointer; nBytes : word ) : word; Assembler;
Asm
	push	di
	push	si

	mov	si, nBytes
	les	di, dataBuf

	xor	bx, bx
	mov	dx, statRG

	xor	cx, cx
	jmp	@@

@@receiveData:
	mov	cx, timeOut
@@:
	in	al, dx
{	in	al, dx}
	in	al, dx
	or	bl, al
	and	al, 00000001b
	loopz	@@
	jnz	@@ob
	mov	bl, 0ffh
	jmp	@@fin
@@ob:
	sub	dx, 5
	in	al, dx
	add	dx, 5
	stosb
	dec	si
	jnz	@@receiveData
@@fin:
	mov	ax, bx
	and	al, 00011110b

	pop	si
	pop	di
End;

{ Return value - number Bytes succsesfully received }
Function ReceiveN( dataBuf : pointer; nBytes : word ) : word; Assembler;
Asm
	push	di
	push	si

	mov	si, nBytes
	les	di, dataBuf

	xor	bx, bx
	mov	dx, statRG

@@receiveData:
	mov	cx, timeOut	{xor	cx, cx}
@@:
	in	al, dx
{	in	al, dx}
	in	al, dx
	or	bl, al
	and	al, 00000001b
	loopz	@@
	jz	@@fin
@@ob:
	sub	dx, 5
	in	al, dx
	add	dx, 5
	stosb
	dec	si
	jnz	@@receiveData
@@fin:
	mov	ax, nBytes
	sub	ax, si
	and	bl, 00011110b
	jz	@@noErrors
	mov	ax, 0ffffh
@@noErrors:
	pop	si
	pop	di
End;

{ Return: 0 - no errors }
Function ClrCOM : word; Assembler;
Asm
	xor	ax, ax
	mov	cx, timeOut	{xor	cx, cx}
	xor	bx, bx
	mov	dx, statRG
@@Wait4Rdy:
	in	al, dx
	xor	al, 01100000b
	jz	@@ob
	sub	dx, 5
	in	al, dx
	add	dx, 5
	mov	cx, timeOut	{xor	cx, cx}
	mov	al, 1
	dec	bx
	jz	@@fin
@@ob:
	loop	@@Wait4Rdy
@@fin:
End;

{ Return value - number Bytes succsesfully received }
Function SendReceiveASCIIZ( sndBuf, rcvBuf : pointer ) : word; Assembler;
Asm
	push	di

	mov	bx, 0

	les	di, sndBuf
	mov	al, byte ptr es:[di]
	or	al, al
	jz	@@fin

	mov	dx, statRG

	dec	dx		{ 3fch modem control }
	mov	al, 00001000b   { bit1 - RTS, bit0 - DTR }
{DTR/RTS}or	al, sndMask
	out	dx, al
	inc	dx

@@sendData:
	mov	cx, timeOut
@@s:
	in	al, dx
	and	al, 00100000b
	loopz	@@s
	jz	@@fin

	mov	al, byte ptr es:[di]
	inc	di
	or	al, al
	jz	@@s0D
	sub	dx, 5
	out	dx, al
	add	dx, 5
	loop	@@sendData
@@s0D:
	mov	al, 0dh
	sub	dx, 5
	out	dx, al
	add	dx, 5

	mov	cx, timeOut
@@wait4fin:
	in	al, dx
	and	al, 01000000b
	loopz	@@wait4fin

	dec	dx		{ 3fch modem control }
	mov	al, 00001000b   { bit1 - RTS, bit0 - DTR }
{DTR/RTS}or	al, rcvMask
	out	dx, al
	inc	dx

{-------------------------------------------------}
	les	di, rcvBuf

	mov	dx, statRG

	xor	ax, ax

	xor	cx, cx
	jmp	@@r

@@receiveData:
	mov	cx, timeOut
@@r:
	in	al, dx
	or	ah, al
	and	al, 00000001b
	loopz	@@r
	jz	@@fin

	sub	dx, 5
	in	al, dx
	add	dx, 5
	cmp	al, 0dh
	je      @@r0D
	stosb
	inc	bx
	loop	@@receiveData
@@r0D:
	xor	al, al
	stosb

	and	ah, 00011110b
	jz	@@fin
{	xor	bx, bx}

@@fin:
	mov	ax, bx

	pop	di
End;

END.

{ Return: 0 - no errors }
Function SendWait( dataBuf : pointer; nBytes : word ) : word; Assembler;
Asm
	push	di

	mov	bx, nBytes
	les	di, dataBuf

	mov	dx, statRG

@@sendData:
	mov	cx, timeOut
@@:
	in	al, dx
	and	al, 00100000b
	loopz	@@
	jz	@@fin

	mov	al, byte ptr es:[di]
	inc	di
	sub	dx, 5
	out	dx, al
	add	dx, 5
	dec	bx
	jnz	@@sendData

	mov	cx, timeOut
@@wait4fin:
	in	al, dx
	and	al, 01100000b
	cmp	al, 01100000b
	loopne	@@wait4fin

@@fin:
	mov	ax, bx

	pop	di
End;

